clear all
close all
clc

n = 10;
nIter = n;
A = full(gallery('tridiag',n,-1,2,-1));

L = 1;
l = linspace(0,L,n);
h = l(2)-l(1);
A = A*(1/h^2);
A(1,1) = 1;
A(1,2) = 0;
A(end,end-1) = 0;
A(end,end) = 1;

b = zeros(n,1);

[V,D] = eig(A);

max(max(abs(A*V-V*D)))

d = diag(D);
%[d,indices] = sort(d,'descend');
%V = V(:,indices);

tau = 1/max(d);

x = zeros(n,nIter);
coef = zeros(n,nIter);
x(:,1) = V(:,1);
res = zeros(nIter,1);
res(1) = norm(b - A*x(:,1));
coef(:,1) = V'*x(:,1);
for i=2:nIter
    x(:,i) = x(:,i-1) + tau*(b - A*x(:,i-1));
    res(i) = norm(b - A*x(:,i));
    
    coef(:,i) = V'*x(:,i);
end

figure
subplot(2,2,1)
ax = gca;
plot(3,d(3),'o','LineWidth',0.5,...
    'MarkerSize',6,...
    'MarkerEdgeColor','k',...
    'MarkerFaceColor',ax.ColorOrder(ax.ColorOrderIndex,:));
hold on 
for i=4:n
    if ax.ColorOrderIndex > size(ax.ColorOrder,1)
        ax.ColorOrderIndex = 1;
    end    
    plot(i,d(i),'o','LineWidth',0.5,...
    'MarkerSize',6,...
    'MarkerEdgeColor','k',...
    'MarkerFaceColor',ax.ColorOrder(ax.ColorOrderIndex,:));
end
plot(1,d(1),'o','LineWidth',0.5,...
    'MarkerSize',6,...
    'MarkerEdgeColor','k',...
    'MarkerFaceColor','r');
plot(2,d(2),'o','LineWidth',0.5,...
    'MarkerSize',6,...
    'MarkerEdgeColor','k',...
    'MarkerFaceColor','r');
hold off
xlim([1,n])

subplot(2,2,2)
ax = gca;
plot(1:nIter,abs(coef(3,:)),'o-','LineWidth',0.5,...
    'MarkerSize',6,...
    'MarkerEdgeColor','k',...
    'MarkerFaceColor',ax.ColorOrder(ax.ColorOrderIndex,:));
hold on 
for i=4:n
    if ax.ColorOrderIndex > size(ax.ColorOrder,1)
        ax.ColorOrderIndex = 1;
    end
    plot(1:nIter,abs(coef(i,:)),'o-','LineWidth',0.5,...
    'MarkerSize',6,...
    'MarkerEdgeColor','k',...
    'MarkerFaceColor',ax.ColorOrder(ax.ColorOrderIndex,:));
end
hold off
xlim([1,nIter])

subplot(2,2,3)
ax = gca;
plot(l,x(:,1),'o-','LineWidth',0.5,...
    'MarkerSize',6,...
    'MarkerEdgeColor','k',...
    'MarkerFaceColor',ax.ColorOrder(ax.ColorOrderIndex,:));
hold on 
for i=2:nIter
    if ax.ColorOrderIndex > size(ax.ColorOrder,1)
        ax.ColorOrderIndex = 1;
    end
    plot(l,x(:,i),'o-','LineWidth',0.5,...
    'MarkerSize',6,...
    'MarkerEdgeColor','k',...
    'MarkerFaceColor',ax.ColorOrder(ax.ColorOrderIndex,:));
end
hold off

subplot(2,2,4)
ax = gca;
plot(1:nIter,res,'o-','LineWidth',0.5,...
    'MarkerSize',6,...
    'MarkerEdgeColor','k',...
    'MarkerFaceColor',ax.ColorOrder(ax.ColorOrderIndex,:));
xlim([1,nIter])

%  https://www.wolframalpha.com/input/?i=g(n%2B1)%3D(1-a)*g(n)%2Bb
%  https://www.wolframalpha.com/input/?i=lim+n-%3Einf+((1-a)%5En+*(-a*b%2Ba*c%2Bb)%2B(a-1)*b)%2F((a-1)*a)+if+-1+%3C+(1-a)+%3C1
