SetFactory("OpenCASCADE");

LX = 10;
lx = 2;
LY = 10;
ly = 2;
LZ = 2;
lix = 1;
liy = 1;

nlix = 10;
nliy = 10;

nloiy = 4;
nloix = 4;
nloey = 4;
nloex = 4;

nLX = 16;
nLY = 16;

nZ1 = 8;
nZ2 = 5;

lc = 1;

dx = 0.;

Point(9)  = { lx+lix+dx,    ly, 0.,     lc};
Point(10)  = { LX,    ly, 0.,     lc};
Point(11)  = { LX,    0, 0.,     lc};
Point(12)  = { lx+lix+dx,    0, 0.,     lc};
Point(13)  = { 0,    0, 0.,     lc};
Point(14)  = { 0,    ly-liy-dx, 0.,     lc};
Point(15)  = { 0,    ly+liy+dx, 0.,     lc};
Point(16)  = { 0,    LY, 0.,     lc};
Point(17)  = { lx,   LY, 0.,     lc};
Point(18)  = { lx,    ly+liy+dx, 0.,     lc};
Point(19)  = { lx-lix-dx,    ly+liy+dx, 0.,     lc};
Point(20)  = { lx-lix-dx,    ly-liy-dx, 0.,     lc};
Point(21)  = { lx+lix+dx,    ly-liy-dx, 0.,     lc};

Point(22)  = { LX,    ly-liy-dx, 0.,     lc};
Point(23)  = { lx-lix-dx,    0, 0.,     lc};
Point(24)  = { lx-lix-dx,    LY, 0.,     lc};
//+
Line(11) = {21, 9};
//+
Line(12) = {21, 12};
//+
Line(13) = {11, 22};
//+
Line(14) = {22, 10};
//+
Line(15) = {23, 20};
//+
Line(16) = {13, 14};
//+
Line(17) = {18, 17};
//+
Line(18) = {24, 19};
//+
Line(19) = {15, 16};
//+
Line(20) = {18, 19};
//+
Line(21) = {19, 15};
//+
Line(22) = {15, 14};
//+
Line(23) = {14, 20};
//+
Line(24) = {20, 19};
//+
Line(25) = {13, 23};
//+
Line(26) = {23, 12};
//+
Line(27) = {21, 20};
//+
Line(28) = {9, 10};
//+
Line(29) = {22, 21};
//+
Line(30) = {12, 11};
//+
Line(31) = {24, 17};
//+
Line(32) = {24, 16};
//+
Line Loop(4) = {19, -32, 18, 21};
//+
Plane Surface(4) = {4};
//+
Line Loop(5) = {17, -31, 18, -20};
//+
Plane Surface(5) = {5};
//+
Line Loop(6) = {24, 21, 22, 23};
//+
Plane Surface(6) = {6};
//+
Line Loop(7) = {16, 23, -15, -25};
//+
Plane Surface(7) = {7};
//+
Line Loop(8) = {26, -12, 27, -15};
//+
Plane Surface(8) = {8};
//+
Line Loop(9) = {12, 30, 13, 29};
//+
Plane Surface(9) = {9};
//+
Line Loop(10) = {11, 28, -14, 29};
//+
Plane Surface(10) = {10};
//+
Transfinite Line {19, 18, 17} = nLY Using Progression 1;
//+
Transfinite Line {28, 29, 30} = nLX Using Progression 1;
//+
Transfinite Line {11, 14} = nloiy Using Progression 1;
//+
Transfinite Line {13, 12, 15, 16} = nloey Using Progression 1;
//+
Transfinite Line {25, 23, 21, 32} = nloex Using Progression 1;
//+
Transfinite Line {20, 31} = nloix Using Progression 1;
//+
Transfinite Line {27, 26} = 2*nloix Using Progression 1;
//+
Transfinite Line {24, 22} = 2*nloiy Using Progression 1;


Transfinite Surface {4};
Transfinite Surface {5};
Transfinite Surface {6};
Transfinite Surface {7};
Transfinite Surface {8};
Transfinite Surface {9};
Transfinite Surface {10};

Recombine Surface {4};
Recombine Surface {5};
Recombine Surface {6};
Recombine Surface {7};
Recombine Surface {8};
Recombine Surface {9};
Recombine Surface {10};


Extrude {0, 0, LZ}
{
  Surface{4,5,6,7,8,9,10}; Layers{nZ2}; Recombine;
}

Physical Volume("body") = {1,2,3,4,5,6,7};
//+
Physical Surface("outer part boundary 1") = {18};
Physical Surface("outer part boundary 2") = {20};
Physical Surface("outer part boundary 3") = {30};
Physical Surface("outer part boundary 4") = {36};
//+
Physical Surface("clamping") = {12, 17};
//+
Physical Surface("load") = {38, 33};
